/*

Here is an example of creating a PickBrowse
that functions equivalent to DCPICKLIST except
it uses Browse objects.

*/

#include "dcdialog.ch"
#INCLUDE "dcpick.CH"
#INCLUDE "appevent.CH"

#command @ <nRow>, <nCol> DCPICKBROW <aPick> LIST <aList>                   ;
              [DATALINK <bLink>]                                            ;
              [PARENT <oParent> ]                                           ;
              [PRESENTATION <aPres>]                                        ;
              [FONT <(font)> ]                                              ;
              [TOOLTIP <cToolTip> ]                                         ;
              [MESSAGE <cMsg> [INTO <oMsg>]]                                ;
              [CARGO <xCargo>]                                              ;
              [SIZE <nWidth> [, <nHeight>] ]                                ;
              [CAPTION <cLeftCap> [,<cRightCap> ] ]                         ;
              [EVAL <bEval> ]                                               ;
              [PIXEL <lPixel>]                                              ;
              [WHEN <bWhen>]                                                ;
              [HIDE<bHide>]                                                 ;
              [OBJECT <oObject>]                                            ;
              [ID <cId> ]                                                   ;
              [TITLE <cTitle> ]                                             ;
              [RELATIVE <oRel> ]                                            ;
              [<lIm:IMMEDIATE>]                                             ;
              [<lVisible:VISIBLE>]                                          ;
              [<lInvisible:INVISIBLE>]                                      ;
              [GROUP <cGroup>]                                              ;
=> ;
[<oObject> :=]                                                              ;
   PickBrowse( GetList,                         ;
    { <aPick>,                                  ;    // 1
      <aList>,                                  ;    // 2
      <nRow>,                                   ;    // 3
      <nCol>,                                   ;    // 4
      <nWidth>,                                 ;    // 5
      <nHeight>,                                ;    // 6
      <font>,                                   ;    // 7
      <oParent>,                                ;    // 8
      <bWhen>,                                  ;    // 9
      <cToolTip>,                               ;    // 10
      <xCargo>,                                 ;    // 11
      <bLink>,                                  ;    // 12
      <cMsg>,                                   ;    // 13
      <oMsg>,                                   ;    // 14
      <lPixel>,                                 ;    // 15
      <bEval>,                                  ;    // 16
      <oRel>,                                   ;    // 17
      <cTitle>,                                 ;    // 18
      <cId>,                                    ;    // 19
      <bHide>,                                  ;    // 20
      <cGroup>,                                 ;    // 21
      <aPres> } )                                    // 22


FUNCTION Main()

LOCAL GetList[0], aList, aPick, oPickBrowse

aList := {'Roger','Brian','Larry','Jeff','Mark','Charlene'}
aPick := {'Samuel','Hortense','Felicia'}

@ 0,0 DCPICKBROW aPick LIST aList SIZE 30,10 PRESENTATION DC_BrowPres()

@12,0 DCPICKLIST aPick LIST aList SIZE 30,10

DCREAD GUI FIT TITLE 'Pick Browse Sample'

RETURN nil

* --------------

PROC appsys
RETURN

* --------------

FUNCTION PickBrowse( GetList, aOptions, GetOptions )

LOCAL nRow, nCol, nWidth, nHeight, oObject, aSizePixels, oList, oPick, ;
      i, aPres, aList2[0], aPick2[0], nPointerList, nPointerPick, ;
      nCol1, nCol2, oParent, aList, aPick, lPixel

nRow := aOptions[3]
nCol := aOptions[4]
nWidth := aOptions[5]
nHeight := aOptions[6]
lPixel := aOptions[15]
aPres := aOptions[22]
aPick := aOptions[1]
aList := aOptions[2]
oParent := aOptions[8]


FOR i := 1 TO Len(aPick)
  AAdd(aPick2,{aPick[i],.f.})
NEXT

FOR i := 1 TO Len(aList)
  AAdd(aList2,{aList[i],.f.})
NEXT

aPick := aPick2
aList := aList2

DEFAULT lPixel := .f.

@ nRow, nCol DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
     SIZE nWidth, nHeight _PIXEL lPixel OBJECT oObject ;
     EVAL {|o|aSizePixels := o:currentSize()}

IF lPixel
  nRow := 3
  nCol1 := 3
  nCol2 := (nWidth/2)
  nWidth := (nWidth/2) - 6
  nHeight := nHeight - 6
ELSE
  nRow := 3/20
  nCol1 := 3/7
  nCol2 := (nWidth/2)
  nWidth := (nWidth/2) - (6/7)
  nHeight := nHeight - (6/20)
ENDIF

@ nRow, nCol1 DCBROWSE oList SIZE nWidth, nHeight ;
   DATA aList ;
   PRESENTATION aPres ;
   NOHSCROLL ;
   PARENT oParent ;
   POINTER nPointerList ;
   COLOR {|x|x:=DC_GetColArray(2,oList),IIF(Empty(x),{nil,GRA_CLR_WHITE},{GRA_CLR_WHITE,GRA_CLR_BLUE})} ;
   ITEMSELECTED {||ListSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick)}

DCBROWSECOL ELEMENT 1 WIDTH nWidth PARENT oList ;
   HEADER 'Available Items' ;
   EVAL {|o|o:dataArea:lbUp := {||LbUp(aList,nPointerList,oList)} } ;

@ nRow, nCol2 DCBROWSE oPick SIZE nWidth, nHeight ;
   DATA aPick ;
   PRESENTATION aPres ;
   NOHSCROLL ;
   PARENT oParent ;
   POINTER nPointerPick ;
   COLOR {|x|x:=DC_GetColArray(2,oPick),IIF(Empty(x),{nil,GRA_CLR_WHITE},{GRA_CLR_WHITE,GRA_CLR_BLUE})} ;
   ITEMSELECTED {||PickSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick)}

DCBROWSECOL ELEMENT 1 WIDTH nWidth PARENT oPick ;
   HEADER 'Selected Items' ;
   EVAL {|o|o:dataArea:lbUp := {||LbUp(aPick,nPointerPick,oPick)} } ;

nRow += .5
@ nRow + nHeight, nCol2 - 10 DCPUSHBUTTON CAPTION '<<' SIZE 5,1 ;
    ACTION {||PickSelected(aList,aPick,oList,oPick,nPointerList,-1)}

@ nRow + nHeight, nCol2 - 5 DCPUSHBUTTON CAPTION '<' SIZE 5,1 ;
    ACTION {||PickSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick)}

@ nRow + nHeight, nCol2 + 0 DCPUSHBUTTON CAPTION '>' SIZE 5,1 ;
    ACTION {||ListSelected(aList,aPick,oList,oPick,nPointerList,nPointerPick)}

@ nRow + nHeight, nCol2 + 5 DCPUSHBUTTON CAPTION '>>' SIZE 5,1 ;
    ACTION {||ListSelected(aList,aPick,oList,oPick,-1,nPointerPick)}

RETURN oObject

* -------------

STATIC FUNCTION lbUp( aArray, nPointer, oBrowse )

IF AppKeyState(xbeK_CTRL) == 1
  aArray[nPointer,2] := !aArray[nPointer,2]
  oBrowse:refreshCurrent()
ENDIF

RETURN nil

* -------------

STATIC FUNCTION ListSelected( aList, aPick, oList, oPick, nPointerList, nPointerPick )

LOCAL i, bError

IF nPointerPick == 0
  nPointerPick := 1
ENDIF

IF nPointerList == 0 .OR. Empty(aList)
  RETURN nil
ENDIF
IF nPointerList > 0
  aList[nPointerList,2] := .T.
ENDIF
FOR i := 1 TO Len(aList)
  IF nPointerList == -1
    aList[i,2] := .T.
  ENDIF
  IF aList[i,2]
    aList[i,2] := .F.
    IF Empty(aPick)
      AAdd( aPick, aList[i])
    ELSE
      ASize(aPick,Len(aPick)+1)
      AIns(aPick,nPointerPick,aList[i])
    ENDIF
    ARemove(aList,i)
    i--
  ENDIF
NEXT
IF Empty(aList)
  AAdd(aList,{'',.f.})
  oList:refreshAll()
  ASize(aList,0)
ENDIF
oList:refreshAll()
oPick:refreshAll()

RETURN nil

* -------------

STATIC FUNCTION PickSelected( aList, aPick, oList, oPick, nPointerList, nPointerPick )

LOCAL i

IF nPointerList == 0
  nPointerList := 1
ENDIF

IF nPointerPick == 0 .OR. Empty(aPick)
  RETURN nil
ENDIF
IF nPointerPick > 0
  aPick[nPointerPick,2] := .T.
ENDIF
FOR i := 1 TO Len(aPick)
  IF nPointerPick == -1
    aPick[i,2] := .T.
  ENDIF
  IF aPick[i,2]
    aPick[i,2] := .F.
    IF Empty(aList)
      AAdd( aList, aPick[i])
    ELSE
      ASize(aList,Len(aList)+1)
      AIns(aList,nPointerList,aPick[i])
    ENDIF
    ARemove(aPick,i)
    i--
  ENDIF
NEXT

IF Empty(aPick)
  AAdd(aPick,{'',.f.})
  oPick:refreshAll()
  ASize(aPick,0)
ENDIF

oList:refreshAll()
oPick:refreshAll()

RETURN nil


